﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CalcHelper
{
    public partial class DescribeSelections : Form
    {
        // Need a var to hold the return value when this form closes..
        // Probably need an enum for the return value...
        public enum desSelOperator { div, mult, sub, add };
        public desSelOperator mathOperator;

        public DescribeSelections(string selectedBoxes)
        {
            InitializeComponent();

            descSelAbortBtn.DialogResult = DialogResult.Abort;
            descBoxSelDivBtn.DialogResult = DialogResult.OK;
            descBoxSelMultBtn.DialogResult = DialogResult.OK;
            descBoxSelMinusBtn.DialogResult = DialogResult.OK;
            descBoxSelPlusBtn.DialogResult = DialogResult.OK;

            // Enter box selection text into textbox so user can see what they selected.
            descSelBoxes.Text = selectedBoxes;
        }

        private void descBoxSelDiv_Click(object sender, EventArgs e)
        {
            this.mathOperator = desSelOperator.div;
            this.Close();
        }

        private void descBoxSelMult_Click(object sender, EventArgs e)
        {
            this.mathOperator = desSelOperator.mult;
            this.Close();
        }

        private void descBoxSelMinus_Click(object sender, EventArgs e)
        {
            this.mathOperator = desSelOperator.sub;
            this.Close();
        }

        private void descBoxSelPlus_Click(object sender, EventArgs e)
        {
            this.mathOperator = desSelOperator.add;
            this.Close();
        }

        private void descSelCancBtn_Click(object sender, EventArgs e)
        {
            //this.DialogResult = DialogResult.Abort;
            this.Close();
        }

        private void DescribeSelections_FormClosing(object sender, FormClosingEventArgs e)
        {
            //In case windows is trying to shut down, don't hold the process up
            if (e.CloseReason == CloseReason.WindowsShutDown) return;

            if (this.DialogResult == DialogResult.Cancel)
            {
                /*
                 * Assume that X has been clicked Confirm user wants to close, in which
                 * case we will treat a 'Yes' response as an abort and all selected boxes
                 * will be un-selected.
                 */
                switch (MessageBox.Show(this, "Are you sure?", "Abort the box selection(s)?", MessageBoxButtons.YesNo, MessageBoxIcon.Question))
                {
                    // Stay on this form.
                    case DialogResult.No:
                        e.Cancel = true;
                        break;

                    default:
                        this.DialogResult = DialogResult.Abort;
                        break;
                }
            }

        }

        private void DescribeSelections_KeyDown(object sender, KeyEventArgs e)
        {
            //MessageBox.Show("Just entered DescribeSelections_KeyDown");
            //MessageBox.Show(string.Format("DescribeSelections_KeyDown - Key: {0}", e.KeyCode));

            // I was trying to detetct these keys from non-numpad keys. Got some to work, will remove soon...

            // Looking for numpad keys: /, *, -, +, and Del.
            switch (e.KeyCode)
            {
                case (Keys.Divide):

                    this.DialogResult = DialogResult.OK;
                    this.mathOperator = desSelOperator.div;
                    this.Close();
                    break;

                case (Keys.Multiply):

                    this.DialogResult = DialogResult.OK;
                    this.mathOperator = desSelOperator.mult;
                    this.Close();
                    break;

                case (Keys.Subtract):
                //case (Keys.OemMinus):

                    this.DialogResult = DialogResult.OK;
                    this.mathOperator = desSelOperator.sub;
                    this.Close();
                    break;

                case (Keys.Add):
                //case (Keys.Oemplus):

                    this.DialogResult = DialogResult.OK;
                    this.mathOperator = desSelOperator.add;
                    this.Close();
                    break;

                // Probably should remove the .Delete as that is not on the numpad.
                //case (Keys.Delete):
                case (Keys.Decimal):
                    
                    this.DialogResult = DialogResult.Abort;
                    this.Close();
                    break;
            }
        }


    }
}
